//+------------------------------------------------------------------+
//|                                                        |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Dserg"
#property  link      ""

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 5
#property indicator_color1 SlateGray
#property indicator_color5 DarkKhaki
#property indicator_color4 DarkKhaki
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Tomato
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 1
#property indicator_style4 STYLE_DOT
#property indicator_style5 STYLE_DOT

//---- buffers
//support
double ChannelUp[];
double ChannelDn[];

double Trend[];
double TrendUp[];
double TrendDn[];
double Volatility[];

//slow
double coeff; 
extern double coeff0_f = 0.2;
extern double coeff0_s = 0.4;
extern int degN = 300;

int Length1 = 5;   //   
extern int Length1_s = 55;   //   
extern int Length1_f = 1;   //   
int Smooth_Mode1 = 6;   //   1  0 - JJMA, 1 - JurX,        
                 // 2 - ParMA, 3 - LRMA, 4 - T3, 5 - SMA, 6 - EMA, 7 - SSMA, 8 - LWMA
//slow
extern double minMA_s = 2.0;
extern double minMA_f = 2.0;
double minMA = 1.0;
extern double Sens = 0.5;
extern int volF = 10;
extern double volP = 1.5;
static int nl,nh;
static bool calcFlag;

double dev = 1.5;
double dev0 = 0.33;
extern bool drawChannels = false;
extern bool paintLine = true;
int Step = 10; // ,       

int Nstat=3000;
extern datetime D0=D'01.02.2011';
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 3additional buffers are used for counting.
   
//---- drawing settings
   IndicatorBuffers(6);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3, ChannelUp);      
   SetIndexLabel(3, "ChannelUP");

   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4, ChannelDn);      
   SetIndexLabel(4, "ChannelDn");
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, Trend);      
   SetIndexLabel(0, "Trend Slow");
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1, TrendUp);      
   SetIndexLabel(1, "TrendUp Slow");
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2, TrendDn);      
   SetIndexLabel(2, "TrendDn Slow");

   SetIndexBuffer(5, Volatility);      

   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0);
   SetIndexEmptyValue(3,0);
   SetIndexEmptyValue(4,0);
   
   calcFlag=false;
   Comment("calculating..");
   MathSrand(12);
   return(0);
  }

int deinit ()
  {
      Comment("");  
  }
int start()

  {

      if (IndicatorCounted() < 0) return(-1); 
      datetime t0 = TimeLocal();
      
      //  
      Nstat = iBarShift(NULL,0,D0);
      if (Nstat>Bars-10) Nstat -=11;
      
      int loopbegin;
      loopbegin = Nstat;
      
      int i;
      
      //slow
      double Brick, Up0, Dn0, BricksUp, BricksDn, lastB, lastS, Profit,K,norm;
      static int dir = 0;
      static double h0,l0;
      double curVol = 0;
      
      
      
      //--------------------------------------------------
      // Slow
      //--------------------------------------------------
      // 
      if (Close[Nstat+10]<=Close[Nstat+1]) {
         l0=Close[Nstat+10];
         h0=Close[Nstat+1];
         dir=1;
         nl=Nstat+10;
         nh=Nstat+1;
      }
      if (Close[Nstat+10]>Close[Nstat+1]) {
         l0=Close[Nstat+1];
         h0=Close[Nstat+10];
         dir=-1;
         nl=Nstat+1;
         nh=Nstat+10;
      }
     //  
      int loopbegin1;
      if (calcFlag) {
         if (Bars - IndicatorCounted()+1 < loopbegin) {
            loopbegin1 = Bars - IndicatorCounted() + 1;
         } else {
            loopbegin1 = loopbegin;
         }
      } else {
         loopbegin1 = loopbegin;
      }
      //MA  ..
      for(i = loopbegin1; i >= 0; i--) {
         Volatility[i] = iCustom(NULL,0,"_MasterSlave",1,9*volF,11*volF,0,5*volF,0,i+1);
         if (Volatility[i]>0) {
            curVol =  MathPow(Volatility[i],volP);
         } else {
            curVol = 0;
         }
         Length1=Length1_s+curVol*(Length1_f-Length1_s);

         Step = Sens*iATR(NULL,0,Nstat,0)/Point;

         double x2ma = iMA(NULL,0,Length1,0,MODE_EMA,PRICE_CLOSE,i+1);
         double  Norma = Step * Point;
         x2ma /= Norma;
         x2ma = NormalizeDouble(x2ma, 0);
         x2ma *= Norma;
         Trend[i] = x2ma;

               
      }
      //
      if (!paintLine) return(0);
      for(i = loopbegin; i >= 0; i--) {
         
         if (Volatility[i]>0) {
            curVol =  MathPow(Volatility[i],volP);
         } else {
            curVol = 0;
         }
         Step = Sens*iATR(NULL,0,Nstat,0)/Point;
      
         // 
         //   
         //   buy
         if (dir>0&&i<Nstat&&Trend[i]>0) {
           // coeff
           coeff=coeff0_s+curVol*(coeff0_f-coeff0_s);
           if (nl>degN){
            coeff=0;
           } else {
            coeff = coeff*(1 - nl/degN);
           } 
           minMA=minMA_s+curVol*(minMA_f-minMA_f);


           double rev0=h0*(1-coeff)+l0*coeff-minMA*Point*Step; // 
           if (Trend[i]<rev0) { //    coeff - 
              dir = -1;
              l0 = Trend[i];
              nl=i;
           }
           if (Trend[i]>h0) { // 
              h0=Trend[i];
              nh=i;
           }
         }
         //   
         if (dir<0&&i<Nstat&&Trend[i]>0) { //   sell
           // coeff
           coeff=coeff0_s+curVol*(coeff0_f-coeff0_s);
           if (nl>degN){
            coeff=0;
           } else {
            coeff = coeff*(1 - nl/degN);
           } 
           minMA=minMA_s+curVol*(minMA_f-minMA_s);

           double rev1=l0*(1-coeff)+h0*coeff + minMA*Point*Step; // 
           if (Trend[i]>rev1) { //    coeff - 
              dir = 1;
              h0 = Trend[i];
              nh=i;
           }
           if (Trend[i]<l0) { // 
              l0=Trend[i];
              nl=i;
           }
         }
         // 
         if (dir>0) {       
            TrendUp[i]=Trend[i];
            TrendDn[i]=0;
         } else {
            TrendDn[i]=Trend[i];
            TrendUp[i]=0;
         }

         // 
         if (drawChannels) {
            //
            double ch0 = iStdDev(NULL,0,Length1,0,MODE_SMA,PRICE_CLOSE,i+1);
            if (dir>0) {       
               ChannelUp[i] = Trend[i] + dev0*dev*ch0;
               ChannelDn[i] = Trend[i] - (1.0-dev0)*dev*ch0;
            } else {
               ChannelUp[i] = Trend[i] + (1.0-dev0)*dev*ch0;
               ChannelDn[i] = Trend[i] - dev*dev0*ch0;
            }
         }
      }
      if (!calcFlag) {
         datetime t1 = TimeLocal()-t0;
         Comment("Calculation done \n  Time " + t1 + " sec.\n Nbars = " + loopbegin1);
         calcFlag=true;
      }
      return(0);
  }
//+------------------------------------------------------------------+



